<?php

/**
 * @copyright Copyright (c) Metaways Infosystems GmbH, 2011
 * @license LGPLv3, http://www.arcavias.com/en/license
 */


class Controller_ExtJS_Admin_Log_DefaultTest extends MW_Unittest_Testcase
{
	private $_object;


	/**
	 * Sets up the fixture, for example, opens a network connection.
	 * This method is called before a test is executed.
	 *
	 * @access protected
	 */
	protected function setUp()
	{
		$this->_object = new Controller_ExtJS_Admin_Log_Default( TestHelper::getContext() );
	}


	/**
	 * Tears down the fixture, for example, closes a network connection.
	 * This method is called after a test is executed.
	 *
	 * @access protected
	 */
	protected function tearDown()
	{
		$this->_object = null;
	}


	public function testSearchItems()
	{
		$params = (object) array(
			'site' => 'unittest',
			'condition' => (object) array( '&&' => array( 0 => (object) array( '==' => (object) array( 'log.message' => 'unittest message' ) ) ) ),
			'sort' => 'log.timestamp',
			'dir' => 'DESC',
			'start' => 0,
			'limit' => 1,
		);

		$result = $this->_object->searchItems( $params );

		$this->assertEquals( 1, count( $result['items'] ) );
		$this->assertEquals( 'unittest message', $result['items'][0]->{'log.message'} );
	}

	public function testDeleteItems()
	{
		$this->setExpectedException( 'Controller_ExtJS_Exception' );
		$this->_object->deleteItems( new stdClass() );
	}


	public function testSaveItems()
	{
		$this->setExpectedException( 'Controller_ExtJS_Exception' );
		$this->_object->saveItems( new stdClass() );
	}

}
